import type { DCloneHTMLElement, DSize } from '../../utils/types';
import type { DDateInputRef } from '../_date-input';
import type { DFormControl } from '../form';
import type { DTimePickerProps } from '../time-picker';
import React from 'react';
export interface DDatePickerProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dRef?: {
        inputLeft?: React.ForwardedRef<HTMLInputElement>;
        inputRight?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dModel?: Date | null | [Date, Date];
    dFormat?: string;
    dVisible?: boolean;
    dInitialVisible?: boolean;
    dPlacement?: 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right';
    dOrder?: 'ascend' | 'descend' | false;
    dPlaceholder?: string | [string?, string?];
    dRange?: boolean;
    dSize?: DSize;
    dClearable?: boolean;
    dDisabled?: boolean;
    dPresetDate?: Record<string, () => Date | [Date, Date]>;
    dConfigDate?: (date: Date, position: 'start' | 'end', current: [Date | null, Date | null]) => {
        disabled?: boolean;
    };
    dShowTime?: boolean | Pick<DTimePickerProps, 'd12Hour' | 'dConfigTime'>;
    dPopupClassName?: string;
    dInputRender?: [
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?,
        DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>?
    ];
    onModelChange?: (date: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onClear?: () => void;
}
export declare const DDatePicker: React.ForwardRefExoticComponent<DDatePickerProps & React.RefAttributes<DDateInputRef>>;
