import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { LoadingOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { TTANSITION_DURING_SLOW } from '../../utils';
import { DCollapseTransition } from '../_transition';
import { usePrefixConfig } from '../root';
export function DItem(props) {
    const { children, dId, dLevel, dIcon, dFocusVisible, dLoading, dDisabled, onItemClick } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const itemIcon = (loading, iconRef, style) => (_jsx("div", Object.assign({ ref: iconRef, className: `${dPrefix}dropdown__item-icon`, style: style }, { children: loading ? _jsx(LoadingOutlined, { dSpin: true }) : dIcon })));
    return (_jsxs("li", Object.assign({ id: dId, className: getClassName(`${dPrefix}dropdown__item`, `${dPrefix}dropdown__item--basic`, {
            'is-disabled': dDisabled || dLoading,
        }), style: { paddingLeft: 12 + dLevel * 16 }, role: "menuitem", "aria-disabled": dDisabled || dLoading, onClick: onItemClick }, { children: [dFocusVisible && _jsx("div", { className: `${dPrefix}focus-outline` }), checkNodeExist(dIcon) ? (itemIcon(dLoading)) : (_jsx(DCollapseTransition, Object.assign({ dOriginalSize: {
                    width: '',
                }, dCollapsedStyle: {
                    width: 0,
                }, dIn: dLoading, dDuring: TTANSITION_DURING_SLOW, dHorizontal: true, dStyles: {
                    entering: {
                        transition: ['width', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_SLOW}ms linear`).join(', '),
                    },
                    leaving: {
                        transition: ['width', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_SLOW}ms linear`).join(', '),
                    },
                    leaved: { display: 'none' },
                }, dDestroyWhenLeaved: true }, { children: (collapseRef, collapseStyle) => itemIcon(true, collapseRef, collapseStyle) }))), _jsx("div", Object.assign({ className: `${dPrefix}dropdown__item-content` }, { children: children }))] })));
}
